﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	'My 2048
	Private PnlApplication As Panel
	Private grid(4, 4), score, highScore, moveCount As Int
	Private LblScore, LblHighScore, LblMoveCount As Label
	Private BtnUp, BtnDown, BtnRight, BtnLeft As Button
	Private startX, startY As Float
	Private PnlCases As Panel
	Private tiles(4, 4) As B4XView

End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")

	'Version 2.0 - 2024/10/19

	LoadHighScore
	InitializeGame
End Sub


#Region 2048
'Resets the game grid to zero and adds two random tiles
Sub InitializeGame
	For i = 0 To 3
		For j = 0 To 3
			grid(i, j) = 0
		Next
	Next
	score = 0
	moveCount = 0
	UpdateScoreLabel
	UpdateMovesLabel
	AddNewTile
	AddNewTile
	DrawGrid
End Sub

'Counts the number of empty spots in the grid and adds a new tile (2 or 4) at a random location
Sub AddNewTile
	Dim emptyCount As Int = 0
	For i = 0 To 3
		For j = 0 To 3
			If grid(i, j) = 0 Then
				emptyCount = emptyCount + 1
			End If
		Next
	Next
	If emptyCount > 0 Then
		Dim randomSpot As Int = Rnd(0, emptyCount)
		Dim count As Int = 0
		For i = 0 To 3
			For j = 0 To 3
				If grid(i, j) = 0 Then
					If count = randomSpot Then
						grid(i, j) = IIf(Rnd(0, 100) < 90, 2, 4)
						Return
					End If
					count = count + 1
				End If
			Next
		Next
	End If

End Sub

'Draws the grid and displays each tile with its corresponding value
Sub DrawGrid
	Dim tileSize As Int = 90dip
	Dim spacing As Int = 5dip
	Dim gridSize As Int = 4 * tileSize + 3 * spacing
	startX = (PnlApplication.Width - gridSize) / 2
	startY = 50dip
	
	For i = 0 To 3
		For j = 0 To 3
			If tiles(i, j).IsInitialized = False Then
				tiles(i, j) = xui.CreatePanel("")
				PnlApplication.AddView(tiles(i, j), startX + j * (tileSize + spacing), startY + i * (tileSize + spacing), tileSize, tileSize)
			End If
			Dim lbl As Label
			If tiles(i, j).NumberOfViews = 0 Then
				lbl.Initialize("")
				tiles(i, j).AddView(lbl, 0, 0, tileSize, tileSize)
			Else
				lbl = tiles(i, j).GetView(0)
			End If
			lbl.Text = IIf(grid(i, j) = 0, "", grid(i, j))
			lbl.TextColor = xui.Color_Black
			lbl.Color = GetTileColor(grid(i, j))
			lbl.Gravity = Gravity.CENTER
			lbl.TextSize = 24
		Next
	Next
	PnlCases.Left = startX - 5dip
	PnlCases.Top = startY - 5dip
	PnlCases.Width = gridSize + 10dip
	PnlCases.Height = gridSize + 10dip
End Sub

Sub GetTileColor(value As Int) As Int
	Select value
		Case 2: Return xui.Color_RGB(238, 228, 218)
		Case 4: Return xui.Color_RGB(237, 224, 200)
		Case 8: Return xui.Color_RGB(242, 177, 121)
		Case 16: Return xui.Color_RGB(245, 149, 99)
		Case 32: Return xui.Color_RGB(246, 124, 95)
		Case 64: Return xui.Color_RGB(246, 94, 59)
		Case 128, 256, 512, 1024, 2048: Return xui.Color_RGB(237, 207, 114)
		Case Else: Return xui.Color_White
	End Select
End Sub

Sub ButtonNew_Click
	InitializeGame
End Sub

Sub CheckGameOver
	For i = 0 To 3
		For j = 0 To 3
			If grid(i, j) = 0 Then Return
			If (i < 3 And grid(i, j) = grid(i + 1, j)) Or (j < 3 And grid(i, j) = grid(i, j + 1)) Then Return
		Next
	Next
	xui.MsgboxAsync("Total moves: " & moveCount & CRLF & "Score: " & score & CRLF & CRLF & "High score: " & highScore, "GAME OVER")
End Sub

'Manages the movement of tiles in the specified direction (left, right, up, down)
Sub Move(direction As String)
	For i = 0 To 3
		Dim tempRow(4) As Int
		Dim index As Int = 0
		For j = 0 To 3
			Dim value As Int
			If direction = "Left" Then
				value = grid(i, j)
			Else If direction = "Right" Then
				value = grid(i, 3 - j)
			Else If direction = "Up" Then
				value = grid(j, i)
			Else If direction = "Down" Then
				value = grid(3 - j, i)
			End If
			If value <> 0 Then
				tempRow(index) = value
				index = index + 1
			End If
		Next
		For j = 0 To index - 2
			If tempRow(j) = tempRow(j + 1) And tempRow(j) <> 0 Then
				tempRow(j) = tempRow(j) * 2
				score = score + tempRow(j)
				tempRow(j + 1) = 0
				index = index - 1
			End If
		Next
		index = 0
		For j = 0 To 3
			If tempRow(j) <> 0 Then
				If direction = "Left" Then
					grid(i, index) = tempRow(j)
				Else If direction = "Right" Then
					grid(i, 3 - index) = tempRow(j)
				Else If direction = "Up" Then
					grid(index, i) = tempRow(j)
				Else If direction = "Down" Then
					grid(3 - index, i) = tempRow(j)
				End If
				index = index + 1
			End If
		Next
		For j = index To 3
			If direction = "Left" Then
				grid(i, j) = 0
			Else If direction = "Right" Then
				grid(i, 3 - j) = 0
			Else If direction = "Up" Then
				grid(j, i) = 0
			Else If direction = "Down" Then
				grid(3 - j, i) = 0
			End If
		Next
	Next
	moveCount = moveCount + 1
End Sub

Private Sub BtnUp_Click
	Move("Up")
	AfterMove
End Sub

Private Sub BtnDown_Click
	Move("Down")
	AfterMove
End Sub

Private Sub BtnLeft_Click
	Move("Left")
	AfterMove
End Sub

Private Sub BtnRight_Click
	Move("Right")
	AfterMove
End Sub

Private Sub AfterMove
	AddNewTile
	DrawGrid
	UpdateScoreLabel
	If score > highScore Then
		highScore = score
		UpdateHighScoreLabel
		SaveHighScore
	End If
	CheckGameOver
	UpdateMovesLabel
	UpdateScoreLabel
End Sub

Private Sub LoadHighScore
	If File.Exists(File.DirInternal, "2048.txt") Then
		highScore = File.ReadString(File.DirInternal, "2048.txt")
	Else
		highScore = 0
		Msgbox(". Each tile moves in one direction until it meets the wall or another tile." & CRLF & CRLF & _
        ". With each move, a new 2 or 4 tile appears at a random location." & CRLF & CRLF & _
        "When a move causes two tiles of the same value to meet, they merge into a single tile" & _
        "with a value equal to the sum of the two tiles. The aim is to create a tile of value 2048.", "GAME RULE") 'ignore
	End If
	UpdateHighScoreLabel
End Sub

Private Sub SaveHighScore
	File.WriteString(File.DirInternal, "2048.txt", highScore)
End Sub

Private Sub UpdateMovesLabel
	LblMoveCount.Text = "Movements: " & moveCount
End Sub

Private Sub UpdateScoreLabel
	LblScore.Text = "Score: " & score
End Sub

Private Sub UpdateHighScoreLabel
	LblHighScore.Text = "High score: " & highScore
End Sub
#End Region
